package maxflow;

import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;

public class TestMaxFlow {

	public static void main(String[] args) {
		Graph g = new SingleGraph("test");
		g.addAttribute("ui.quality");
		g.addAttribute("ui.antialias");

		g.addNode("s");
		g.addNode("1");
		g.addNode("2");
		g.addNode("t");
		g.addEdge("e1", "s", "1", true).addAttribute("cap", 10);
		g.addEdge("e2", "s", "2", true).addAttribute("cap", 10);
		g.addEdge("e3", "1", "2", true).addAttribute("cap", 5);
		g.addEdge("e4", "1", "t", true).addAttribute("cap", 8);
		g.addEdge("e5", "2", "t", true).addAttribute("cap", 7);
		g.display();
		
		MaxFlow mf = new MaxFlow();
		mf.setCapacityAttribute("cap");
		mf.init(g);
		mf.setSource(g.getNode("s"));
		mf.setSink(g.getNode("t"));
		mf.compute();
		
		System.out.println(mf.getFlow());
		for (Edge e : g.getEachEdge()) {
			double flow = mf.getFlow(e);
			double cap = mf.getCapacity(e);
			e.addAttribute("ui.label", "" + flow + " / " + cap);
			if (cap == flow) e.addAttribute("ui.style", "fill-color: red;");
		}

		for( Node o : g.getEachNode() )
		{
			o.setAttribute("ui.label", o.getId());
		}

	}

}
